Index: trunk/SophyaPI/PIext/basexecut.cc
===================================================================
--- trunk/SophyaPI/PIext/basexecut.cc	(revision 2343)
+++ trunk/SophyaPI/PIext/basexecut.cc	(revision 2350)
@@ -1137,16 +1137,6 @@
 usage += ">> lut=ltyp,min,max -> Sets LUT type and min/max for image display \n";
 usage += "                       (ltyp=lin/log/sqrt/square) \n";
-usage += ">> Axes:  stdaxes=defaxes=boxaxes boxaxesgrid centeredaxes\n";
-usage += "          fineaxes finecenteredaxes fineaxesgrid\n"; 
-usage += "          centeredaxesgrid finecenteredaxesgrid \n"; 
-usage += "          grid nogrid labels nolabels ticks noticks \n"; 
-usage += "          minorticks nominorticks extticks intticks axesnone \n"; 
-usage += ">> Axe labels font size: fixedfontsize/autofontsize \n";
-usage += "          autofontsize: Font size computed automatically \n";
-usage += "          fixedfontsize: Use font size attribute (BaseDrawer) \n";
-usage += ">> LogScale : linx liny logx logy -> Lin/Log Scales for 2D plots \n";
-usage += ">> xylimits=xmin,xmax,ymin,ymax  -> Forces X-Y limits in 2-D plots \n";
-usage += ">> defdrrect=xmin,xmax,ymin,ymax -> Defines drawing rectangle 2-D plots \n";
-usage += "          The rectangle is defined as a fraction of the widget size\n";
+usage += ">> Axes / Axe labels / LogScale / xylimits / defdrrect \n";
+usage += "   See setaxesatt command \n";
 usage += ">> stat/nostat or stats/nostats -> Toggle statistic display flag \n";
 usage += ">> title/notitle or tit/notit -> Toggle Auto AddTitle flag \n";
@@ -1158,11 +1148,14 @@
 usage = "To set default axes attributes \n  Usage: setaxesatt att_list \n";
 usage += "Color/Line/Font attributes and axes attributes \n";
-usage += ">> Axes:  stdaxes=defaxes=boxaxes boxaxesgrid centeredaxes\n";
-usage += "          fineaxes finecenteredaxes fineaxesgrid \n"; 
+usage += ">> Axes:  axesnone stdaxes=defaxes=boxaxes boxaxesgrid \n";
+usage += "          fineaxes fineaxesgrid centeredaxes finecenteredaxes \n"; 
 usage += "          centeredaxesgrid finecenteredaxesgrid \n"; 
-usage += "          grid nogrid labels nolabels ticks noticks \n"; 
-usage += "          minorticks nominorticks extticks intticks axesnone \n"; 
-usage += ">> Axe labels font size: fixedfontsize/autofontsize \n";
-usage += "          autofontsize: Font size computed automatically \n";
+usage += "          grid nogrid labels nolabels  \n"; 
+usage += "          ticks noticks minorticks nominorticks \n"; 
+usage += "          extticks intticks extintticks \n"; 
+usage += "          nbticks=X_NTicks,Y_NTicks  \n"; 
+usage += "          tickslen=MajTickLenFrac,MinTickLenFrac \n"; 
+usage += ">> Axe labels font size: fixedfontsize/autofontsize=fszf \n";
+usage += "          autofontsize=fsizef: Font size computed automatically \n";
 usage += "          fixedfontsize: Use font size attribute (BaseDrawer) \n";
 usage += ">> LogScale : linx liny logx logy -> Lin/Log Scales for 2D plots \n";
Index: trunk/SophyaPI/PIext/piaversion.h
===================================================================
--- trunk/SophyaPI/PIext/piaversion.h	(revision 2343)
+++ trunk/SophyaPI/PIext/piaversion.h	(revision 2350)
@@ -2,5 +2,5 @@
 #define PIAPPVERSION_H_SEEN
 
-#define PIAPP_VERSIONNUMBER  3.90
+#define PIAPP_VERSIONNUMBER  3.93
 
 #endif
Index: trunk/SophyaPI/PIext/pihisto2d.cc
===================================================================
--- trunk/SophyaPI/PIext/pihisto2d.cc	(revision 2343)
+++ trunk/SophyaPI/PIext/pihisto2d.cc	(revision 2350)
@@ -696,5 +696,5 @@
 //|     et de l'histogramme.
 //--
-: PIWindow((PIMsgHandler *)par,"Options",PIWK_dialog,250,260,150,150)
+: PIWindow((PIMsgHandler *)par,"H2D-Options",PIWK_dialog,250,260,150,150)
 , mFgCol(false), mCmap(CMAP_GREYINV32), mRevCmap(false)
 , mTypScal(0)  , mLogScale(10.)
Index: trunk/SophyaPI/PIext/pintup3d.cc
===================================================================
--- trunk/SophyaPI/PIext/pintup3d.cc	(revision 2343)
+++ trunk/SophyaPI/PIext/pintup3d.cc	(revision 2350)
@@ -207,6 +207,5 @@
   yp = mNT->GetCell(i, yK);
   zp = mNT->GetCell(i, zK);
-  if ( (i > 0) && 
-       (GetGraphicAtt().GetLineAtt() != PI_NotDefLineAtt) )   // On relie les points ...
+  if ( (i > 0) && connectPts ) // On relie les points ...
     g3->DrawLine3D(xl, yl, zl, xp, yp, zp);
   nok++;
@@ -241,2 +240,64 @@
 }
 
+/*  La methode DecodeOptionString permet de decoder un ensemble d'options 
+    et de parametre d'affichage specifie sous forme d'un vecteur de string.
+    Si rmdecopt == true, les options decodees sont supprimees du vecteur 
+    de string fourni en entree - ce qui permet l'enchainement eventuel 
+    de plusieurs decodages de string.
+    Les options peuvent etre sous forme de flag : "stat" "nostat" 
+    ou plus complexes, par exemple "dynamic=-3,3"
+    Rc: La methode renvoie le nombre d'options decodees 
+*/
+
+/* --Methode-- */
+int PINTuple3D::DecodeOptionString(vector<string> & opt, bool rmdecopt)
+{
+  int optsz1 = opt.size();
+  if(optsz1<1)  return(0);  
+  // On appelle d'abord le decodage de la classe PIDrawer de laquelle
+  // on herite. (Pas obligatoire) on decode donc ici les attributs de
+  // couleur, fontes ...
+  int ndec1 = PIDrawer::DecodeOptionString(opt, rmdecopt);
+  if(optsz1-ndec1<1) return(ndec1);  // si tout a ete decode
+
+  vector<string> udopt;  // On gardera ici les options non decodees
+  unsigned int k = 0;
+  int ndec = opt.size();
+  for( k=0; k<opt.size(); k++ ) {
+    string opts = opt[k];
+    //    if(opts=="sta" || opts=="stat" || opts=="stats") SetStats(true);
+    //    else if(  opts=="nsta"   || opts=="nstat"
+    //           || opts=="nostat" || opts=="nostats") SetStats(false);
+    if (opts == "connectpoints") ConnectPoints(true);
+    else if (opts == "noconnectpoints") ConnectPoints(false);
+    else {
+      // Si option non decode
+      ndec--;
+      // S'il faut supprimer les options decodees
+      if (rmdecopt)  udopt.push_back(opts);
+    }
+  }  
+  // S'il faut supprimer les options decodees, on remplace l'argument opt
+  // par le vecteur des options non decodees.
+  if (rmdecopt)  opt = udopt;
+  return(ndec+ndec1);  
+}
+
+/* La methode GetOptionsHelpInfo(string& info) renvoie une chaine 
+   avec la description des options comprises par ce drawer  
+   Note: Il est preferable de ne pas initialiser la chaine 
+   string info au depart, afin de permettre de mettre bout a 
+   bout les aides de differents Drawer */
+
+/* --Methode-- */
+void PINTuple3D::GetOptionsHelpInfo(string& info)
+{
+// On recupere d'abord la chaine info de la classe de base
+PIDrawer::GetOptionsHelpInfo(info);
+info += " ---- PINTuple3D options help info : \n" ;
+info += "  connectpoints: The points are connected by a line \n";
+info += "  noconnectpoints (this is the default) \n";
+info += "  and usual color/line/marker/... attribute decoding  \n";
+return;
+}
+
Index: trunk/SophyaPI/PIext/pintup3d.h
===================================================================
--- trunk/SophyaPI/PIext/pintup3d.h	(revision 2343)
+++ trunk/SophyaPI/PIext/pintup3d.h	(revision 2350)
@@ -18,4 +18,10 @@
   virtual void       SelectLabel(const char* plabel);
 
+  inline  void       ConnectPoints(bool fg=false) { connectPts = fg; }
+
+//   Methode de decodage des options
+  virtual int        DecodeOptionString(vector<string> & opt, bool rmdecopt=true);
+//   Texte d'aide des options disponibles
+  virtual void       GetOptionsHelpInfo(string& info);
        
 protected:
@@ -29,4 +35,6 @@
   int nWbins;               // Nombre de bins pour le poids (Wt)
 
+  bool connectPts;          // true -> les points sont relies par une ligne
+
 };
 
Index: trunk/SophyaPI/PIext/pintuple.cc
===================================================================
--- trunk/SophyaPI/PIext/pintuple.cc	(revision 2343)
+++ trunk/SophyaPI/PIext/pintuple.cc	(revision 2350)
@@ -46,4 +46,5 @@
   mAdDO = ad; 
   SetStats(true);
+  ConnectPoints(false);
   SelectXY(NULL, NULL);
   SelectWt(NULL, 1);
@@ -177,5 +178,5 @@
   nok++;
   if ( (xp < xmin) || (xp > xmax) || (yp < ymin) || (yp > ymax) )  continue;
-  if ( (i > 0) && (GetGraphicAtt().GetLineAtt() != PI_NotDefLineAtt) )   
+  if ( (i > 0) && connectPts )   
     g->DrawLine(xl, yl, xp, yp);  // On relie les points ...
   if ( xebK >= 0 ) {
@@ -286,4 +287,6 @@
     else if(  opts=="nsta"   || opts=="nstat"
            || opts=="nostat" || opts=="nostats") SetStats(false);
+    else if (opts == "connectpoints") ConnectPoints(true);
+    else if (opts == "noconnectpoints") ConnectPoints(false);
     else {
       // Si option non decode
@@ -311,6 +314,9 @@
 PIDrawer::GetOptionsHelpInfo(info);
 info += " ---- PINTuple options help info : \n" ;
-info += "- sta,stat,stats:            activate   statistic display\n";
+info += "  sta,stat,stats:            activate   statistic display\n";
 info += "  nsta,nstat,nostat,nostats: deactivate statistic display\n";
+info += "  connectpoints: The points are connected by a line \n";
+info += "  noconnectpoints (this is the default) \n";
+info += "  and usual color/line/marker/... attribute decoding  \n";
 return;
 }
Index: trunk/SophyaPI/PIext/pintuple.h
===================================================================
--- trunk/SophyaPI/PIext/pintuple.h	(revision 2343)
+++ trunk/SophyaPI/PIext/pintuple.h	(revision 2350)
@@ -24,4 +24,6 @@
 
   inline  void       SetStats(bool fg=true) { stats = fg; }
+  inline  void       ConnectPoints(bool fg=false) { connectPts = fg; }
+
   virtual void       AppendTextInfo(string& info, double xmin, double ymin, double xmax, double ymax);
 
@@ -41,4 +43,5 @@
   int nWbins;               // Nombre de bins pour le poids (Wt)
   bool stats;               // true -> indication du nb de points
+  bool connectPts;          // true -> les points sont relies par une ligne
 };
 
Index: trunk/SophyaPI/PIext/pistdimgapp.cc
===================================================================
--- trunk/SophyaPI/PIext/pistdimgapp.cc	(revision 2343)
+++ trunk/SophyaPI/PIext/pistdimgapp.cc	(revision 2350)
@@ -287,5 +287,5 @@
 
 // Attributs graphiques courants
-mAxesFlags = kBoxAxes | kExtTicks | kLabels;
+mAxesFlags = kAxesDflt;
 SetInsetLimits(0.4, 0.6, 0.4, 0.6);
 mAddTitle = true;