Index: trunk/SophyaPI/PI/picmap.cc
===================================================================
--- trunk/SophyaPI/PI/picmap.cc	(revision 2358)
+++ trunk/SophyaPI/PI/picmap.cc	(revision 2372)
@@ -23,11 +23,13 @@
 //--
 
-#define  MXMAPIDS   22
+#define  MXMAPIDS   26
 static   int    MapNCols[MXMAPIDS] = {256, 256, 256, 256, 256, 256, 256, 256, 256, 256,
-                            256, 256, 256, 256, 256, 256, 256, 256, 256, 256, 256, 256 };
+                            256, 256, 256, 256, 256, 256, 256, 256, 256, 256, 256, 256,
+256, 256, 256, 256};
 
 // Tables de couleurs :
 // 5 Standard PI , 32  couleurs
 // 4 Standard PI , 128 couleurs
+// 4 Standard PI , 32 couleurs uniformes
 // 12 MIDAS , 256 couleurs
 // 1 Standard PI 16 couleurs
@@ -36,4 +38,5 @@
                       "Grey32","InvGrey32","ColRJ32","ColBR32","ColRV32", 
                       "Grey128","InvGrey128","ColRJ128","ColBR128",
+		      "Red32","Green32","Blue32","Yellow32",
                       "MIDAS_Pastel","MIDAS_Heat","MIDAS_Rainbow3", 
                       "MIDAS_BlueRed","MIDAS_BlueWhite","MIDAS_Stairs8",
@@ -45,4 +48,5 @@
                       CMAP_GREY32, CMAP_GREYINV32, CMAP_COLRJ32, CMAP_COLBR32, CMAP_COLRV32, 
                       CMAP_GREY128, CMAP_GREYINV128, CMAP_COLRJ128, CMAP_COLBR128,  
+		      CMAP_RED32, CMAP_GREEN32, CMAP_BLUE32, CMAP_YELLOW32,
                       CMAP_MIDAS_Pastel, CMAP_MIDAS_Heat, CMAP_MIDAS_Rainbow3, 
                       CMAP_MIDAS_BlueRed, CMAP_MIDAS_BlueWhite, CMAP_MIDAS_Stairs8, 
@@ -59,5 +63,7 @@
                                   NULL, NULL, NULL, NULL, NULL, 
                                   NULL, NULL, NULL, NULL, NULL,
-                                  NULL  };
+                                  NULL, NULL, NULL, NULL, NULL,
+                                  NULL, NULL, NULL, NULL, NULL, 
+                                  NULL };
 
 int  PIColorMap::NumberStandardColorMaps()
@@ -101,4 +107,8 @@
 //|	CMAP_COLRJ128   :  128 couleurs, du Rouge au Jaune/blanc
 //|	CMAP_COLBR128   :  128 couleurs du bleu au rouge (arcenciel)
+//|	CMAP_RED32      :  32 couleurs, nuances de rouge
+//|	CMAP_GREEN32    :  32 couleurs, nuances de vert
+//|	CMAP_BLUE32     :  32 couleurs, nuances de bleu
+//|	CMAP_YELLOW32   :  32 couleurs, nuances de jaune
 //|	CMAP_COL16      :  16 Couleurs arcenciel
 //|	CMAP_OTHER      :  Table non standard (Midas,Idl, ...)
@@ -416,4 +426,46 @@
       }
       break;
+
+    // Nuances de couleurs uniformes
+    case CMAP_RED32 :
+    case CMAP_GREEN32 :
+    case CMAP_BLUE32 :
+    case CMAP_YELLOW32 :
+      for(i=0; i<6; i++) {
+	int vcol = i*4000;
+	mycol.red = mycol.green = mycol.blue = 0;
+	if (mType == CMAP_RED32) mycol.red = vcol;
+	else if (mType == CMAP_GREEN32)  mycol.green = vcol;
+	else if (mType == CMAP_BLUE32)  mycol.blue = vcol;
+	else if (mType == CMAP_YELLOW32) mycol.green = mycol.red = vcol;
+        for(k=0; k<8; k++)     AllocColor(mycol, i*8+k);
+      }
+      for(i=6; i<16; i++) {
+	int vcol = 20000+(i-5)*2500;
+	mycol.red = mycol.green = mycol.blue = 0;
+	if (mType == CMAP_RED32) mycol.red = vcol;
+	else if (mType == CMAP_GREEN32)  mycol.green = vcol;
+	else if (mType == CMAP_BLUE32)  mycol.blue = vcol;
+	else if (mType == CMAP_YELLOW32) mycol.green = mycol.red = vcol;
+        for(k=0; k<8; k++)     AllocColor(mycol, i*8+k);
+      }
+      for(i=16; i<32; i++) {
+       	int vcol = 45000+(i-15)*1283.4;
+	mycol.red = mycol.green = mycol.blue = 0;
+	if (mType == CMAP_RED32) mycol.red = vcol;
+	else if (mType == CMAP_GREEN32)  mycol.green = vcol;
+	else if (mType == CMAP_BLUE32)  mycol.blue = vcol;
+	else if (mType == CMAP_YELLOW32) mycol.green = mycol.red = vcol;
+        for(k=0; k<8; k++)     AllocColor(mycol, i*8+k);
+      }
+      for(i=6; i<20; i++) {
+	mycol.green = mycol.blue = 0;
+        mycol.red = 20000+(i-5)*2000;
+        for(k=0; k<8; k++)     AllocColor(mycol, i*8+k);
+      }
+      break;
+
+//----------------------------------------------------------
+//----------------------------------------------------------
 
   case CMAP_MIDAS_Pastel :   // pastel.lutlis
Index: trunk/SophyaPI/PI/picmap.h
===================================================================
--- trunk/SophyaPI/PI/picmap.h	(revision 2358)
+++ trunk/SophyaPI/PI/picmap.h	(revision 2372)
@@ -22,4 +22,10 @@
  CMAP_COLRJ128    = 8,     // 128 couleurs du rouge au jaune/blanc
  CMAP_COLBR128    = 9,     // 128 couleurs du bleu au rouge
+
+ // Nuances de couleurs uniformes
+ CMAP_RED32       = 11,    // 32 couleurs - nuances de rouge
+ CMAP_GREEN32     = 12,    // 32 couleurs - nuances de vert
+ CMAP_BLUE32      = 13,    // 32 couleurs - nuances de bleu
+ CMAP_YELLOW32    = 14,    // 32 couleurs - nuances de jaune
 
  // Tables de couleur importees de MIDAS   256 couleurs
Index: trunk/SophyaPI/PI/pidrwtools.cc
===================================================================
--- trunk/SophyaPI/PI/pidrwtools.cc	(revision 2358)
+++ trunk/SophyaPI/PI/pidrwtools.cc	(revision 2372)
@@ -164,7 +164,8 @@
 //  Groupement des tables de couleurs
 mCasc[0] = new PIMenu(mOpt[1]->Menu(), "PIStd-128Col");
-mCasc[1] = new PIMenu(mOpt[1]->Menu(), "MIDAS-CMap");
-
-int nsct1,nsct2,nsct3;
+mCasc[1] = new PIMenu(mOpt[1]->Menu(), "PIUniCol32");
+mCasc[2] = new PIMenu(mOpt[1]->Menu(), "MIDAS-CMap");
+
+int nsct1,nsct2,nsct3,nsct4;
 //  D'abord les tables standard de PI  32 couleurs
 nsct1 = 5;   // Les 5 premieres tables
@@ -176,11 +177,15 @@
   mCasc[0]->AppendItem(PIColorMap::GetStandardColorMapName(kcc).c_str(), 201+kcc);
 mOpt[1]->AppendPDMenu(mCasc[0]);
-//  Apres les tables importees de MIDAS
-nsct3 = PIColorMap::NumberStandardColorMaps()-1; // Les reste jusqu'a l'avant derniere
+nsct3 = 13;  // Les 4 tables de couleurs uniforme
 for(kcc=nsct2; kcc<nsct3; kcc++) 
   mCasc[1]->AppendItem(PIColorMap::GetStandardColorMapName(kcc).c_str(), 201+kcc);
 mOpt[1]->AppendPDMenu(mCasc[1]);
+//  Apres les tables importees de MIDAS
+nsct4 = PIColorMap::NumberStandardColorMaps()-1; // Les reste jusqu'a l'avant derniere
+for(kcc=nsct3; kcc<nsct4; kcc++) 
+  mCasc[2]->AppendItem(PIColorMap::GetStandardColorMapName(kcc).c_str(), 201+kcc);
+mOpt[1]->AppendPDMenu(mCasc[2]);
 // Les tables qui restent ( Col16 , ... )
-for(kcc=nsct3; kcc<PIColorMap::NumberStandardColorMaps(); kcc++) 
+for(kcc=nsct4; kcc<PIColorMap::NumberStandardColorMaps(); kcc++) 
 mOpt[1]->AppendItem(PIColorMap::GetStandardColorMapName(kcc).c_str(), 201+kcc);
 
@@ -362,5 +367,5 @@
 for(i=0; i<2; i++) delete mButdr[i]; 
 for(i=0; i<10 ; i++)  delete mOpt[i];
-for(i=0; i<2; i++)  delete mCasc[i];
+for(i=0; i<3; i++)  delete mCasc[i];
 delete mNlb;
 delete mDrName;
Index: trunk/SophyaPI/PI/piimgtools.cc
===================================================================
--- trunk/SophyaPI/PI/piimgtools.cc	(revision 2358)
+++ trunk/SophyaPI/PI/piimgtools.cc	(revision 2372)
@@ -154,7 +154,8 @@
 //  Groupement des tables de couleurs
 mCasc[0] = new PIMenu(mOptzc[0]->Menu(), "PIStd-128Col");
-mCasc[1] = new PIMenu(mOptzc[0]->Menu(), "MIDAS-CMap");
-
-int nsct1,nsct2,nsct3;
+mCasc[1] = new PIMenu(mOptzc[0]->Menu(), "PIUniCol32");
+mCasc[2] = new PIMenu(mOptzc[0]->Menu(), "MIDAS-CMap");
+
+int nsct1,nsct2,nsct3,nsct4;
 //  D'abord les tables standard de PI  32 couleurs
 nsct1 = 5;   // Les 5 premieres tables
@@ -166,11 +167,15 @@
   mCasc[0]->AppendItem(PIColorMap::GetStandardColorMapName(kcc).c_str(), 201+kcc);
 mOptzc[0]->AppendPDMenu(mCasc[0]);
-//  Apres les tables importees de MIDAS
-nsct3 = PIColorMap::NumberStandardColorMaps()-1; // Les reste jusqu'a l'avant derniere
+nsct3 = 13;  // Les 4 tables de couleurs uniforme
 for(kcc=nsct2; kcc<nsct3; kcc++) 
   mCasc[1]->AppendItem(PIColorMap::GetStandardColorMapName(kcc).c_str(), 201+kcc);
 mOptzc[0]->AppendPDMenu(mCasc[1]);
+//  Apres les tables importees de MIDAS
+nsct4 = PIColorMap::NumberStandardColorMaps()-1; // Les reste jusqu'a l'avant derniere
+for(kcc=nsct3; kcc<nsct4; kcc++) 
+  mCasc[2]->AppendItem(PIColorMap::GetStandardColorMapName(kcc).c_str(), 201+kcc);
+mOptzc[0]->AppendPDMenu(mCasc[2]);
 // Les tables qui restent ( Col16 , ... )
-for(kcc=nsct3; kcc<PIColorMap::NumberStandardColorMaps(); kcc++) 
+for(kcc=nsct4; kcc<PIColorMap::NumberStandardColorMaps(); kcc++) 
 mOptzc[0]->AppendItem(PIColorMap::GetStandardColorMapName(kcc).c_str(), 201+kcc);
 // On ajoute un CheckItem pour inverser les index de table de couleur