Index: /trunk/SophyaPI/PI/picmap.cc
===================================================================
--- /trunk/SophyaPI/PI/picmap.cc	(revision 2375)
+++ /trunk/SophyaPI/PI/picmap.cc	(revision 2376)
@@ -23,5 +23,5 @@
 //--
 
-#define  MXMAPIDS   26
+#define  MXMAPIDS   29
 static   int    MapNCols[MXMAPIDS] = {256, 256, 256, 256, 256, 256, 256, 256, 256, 256,
                             256, 256, 256, 256, 256, 256, 256, 256, 256, 256, 256, 256,
@@ -39,5 +39,6 @@
                       "Grey128","InvGrey128","ColRJ128","ColBR128",
 		      "Red32CM","Green32CM","Blue32CM","Yellow32CM",
-                      "MIDAS_Pastel","MIDAS_Heat","MIDAS_Rainbow3", 
+ 		      "Orange32CM","Cyan32CM","Violet32CM",
+		      "MIDAS_Pastel","MIDAS_Heat","MIDAS_Rainbow3", 
                       "MIDAS_BlueRed","MIDAS_BlueWhite","MIDAS_Stairs8",
                       "MIDAS_Stairs9","MIDAS_StairCase","MIDAS_Color",
@@ -49,4 +50,5 @@
                       CMAP_GREY128, CMAP_GREYINV128, CMAP_COLRJ128, CMAP_COLBR128,  
 		      CMAP_RED32, CMAP_GREEN32, CMAP_BLUE32, CMAP_YELLOW32,
+		      CMAP_ORANGE32, CMAP_CYAN32, CMAP_VIOLET32, 
                       CMAP_MIDAS_Pastel, CMAP_MIDAS_Heat, CMAP_MIDAS_Rainbow3, 
                       CMAP_MIDAS_BlueRed, CMAP_MIDAS_BlueWhite, CMAP_MIDAS_Stairs8, 
@@ -65,5 +67,5 @@
                                   NULL, NULL, NULL, NULL, NULL,
                                   NULL, NULL, NULL, NULL, NULL, 
-                                  NULL };
+                                  NULL, NULL, NULL, NULL };
 
 int  PIColorMap::NumberStandardColorMaps()
@@ -111,4 +113,7 @@
 //|	CMAP_BLUE32     :  32 couleurs, nuances de bleu
 //|	CMAP_YELLOW32   :  32 couleurs, nuances de jaune
+//|	CMAP_ORANGE32   :  32 couleurs, nuances d'orange
+//|	CMAP_CYAN32     :  32 couleurs, nuances de cyan
+//|	CMAP_VIOLET32   :  32 couleurs, nuances de violet
 //|	CMAP_COL16      :  16 Couleurs arcenciel
 //|	CMAP_OTHER      :  Table non standard (Midas,Idl, ...)
@@ -432,4 +437,7 @@
     case CMAP_BLUE32 :
     case CMAP_YELLOW32 :
+    case CMAP_ORANGE32 :
+    case CMAP_CYAN32 :
+    case CMAP_VIOLET32 :
       for(i=0; i<6; i++) {
 	int vcol = i*4000;
@@ -439,4 +447,8 @@
 	else if (mType == CMAP_BLUE32)  mycol.blue = vcol;
 	else if (mType == CMAP_YELLOW32) mycol.green = mycol.red = vcol;
+	else if (mType == CMAP_ORANGE32) { mycol.red = vcol; mycol.green = vcol*0.65; }
+	else if (mType == CMAP_CYAN32) mycol.green = mycol.blue = vcol; 
+	else if (mType == CMAP_VIOLET32) 
+	  { mycol.red = 0.6*vcol; mycol.green = 0.2*vcol; mycol.blue = vcol; }
         for(k=0; k<8; k++)     AllocColor(mycol, i*8+k);
       }
@@ -448,4 +460,8 @@
 	else if (mType == CMAP_BLUE32)  mycol.blue = vcol;
 	else if (mType == CMAP_YELLOW32) mycol.green = mycol.red = vcol;
+	else if (mType == CMAP_ORANGE32) { mycol.red = vcol; mycol.green = vcol*0.65; }
+	else if (mType == CMAP_CYAN32) mycol.green = mycol.blue = vcol; 
+	else if (mType == CMAP_VIOLET32) 
+	  { mycol.red = 0.6*vcol; mycol.green = 0.2*vcol; mycol.blue = vcol; }
         for(k=0; k<8; k++)     AllocColor(mycol, i*8+k);
       }
@@ -457,4 +473,8 @@
 	else if (mType == CMAP_BLUE32)  mycol.blue = vcol;
 	else if (mType == CMAP_YELLOW32) mycol.green = mycol.red = vcol;
+	else if (mType == CMAP_ORANGE32) { mycol.red = vcol; mycol.green = vcol*0.65; }
+	else if (mType == CMAP_CYAN32) mycol.green = mycol.blue = vcol; 
+	else if (mType == CMAP_VIOLET32) 
+	  { mycol.red = 0.6*vcol; mycol.green = 0.2*vcol; mycol.blue = vcol; }
         for(k=0; k<8; k++)     AllocColor(mycol, i*8+k);
       }
Index: /trunk/SophyaPI/PI/picmap.h
===================================================================
--- /trunk/SophyaPI/PI/picmap.h	(revision 2375)
+++ /trunk/SophyaPI/PI/picmap.h	(revision 2376)
@@ -28,4 +28,7 @@
  CMAP_BLUE32      = 13,    // 32 couleurs - nuances de bleu
  CMAP_YELLOW32    = 14,    // 32 couleurs - nuances de jaune
+ CMAP_ORANGE32    = 15,    // 32 couleurs - nuances d' orange
+ CMAP_CYAN32      = 16,    // 32 couleurs - nuances de cyan
+ CMAP_VIOLET32    = 17,    // 32 couleurs - nuances de violet
 
  // Tables de couleur importees de MIDAS   256 couleurs
Index: /trunk/SophyaPI/PI/pidrwtools.cc
===================================================================
--- /trunk/SophyaPI/PI/pidrwtools.cc	(revision 2375)
+++ /trunk/SophyaPI/PI/pidrwtools.cc	(revision 2376)
@@ -177,5 +177,5 @@
   mCasc[0]->AppendItem(PIColorMap::GetStandardColorMapName(kcc).c_str(), 201+kcc);
 mOpt[1]->AppendPDMenu(mCasc[0]);
-nsct3 = 13;  // Les 4 tables de couleurs uniforme
+nsct3 = 17;  // Les 7 tables de couleurs uniforme
 for(kcc=nsct2; kcc<nsct3; kcc++) 
   mCasc[1]->AppendItem(PIColorMap::GetStandardColorMapName(kcc).c_str(), 201+kcc);
Index: /trunk/SophyaPI/PI/piimgtools.cc
===================================================================
--- /trunk/SophyaPI/PI/piimgtools.cc	(revision 2375)
+++ /trunk/SophyaPI/PI/piimgtools.cc	(revision 2376)
@@ -167,5 +167,5 @@
   mCasc[0]->AppendItem(PIColorMap::GetStandardColorMapName(kcc).c_str(), 201+kcc);
 mOptzc[0]->AppendPDMenu(mCasc[0]);
-nsct3 = 13;  // Les 4 tables de couleurs uniforme
+nsct3 = 16;  // Les 7 tables de couleurs uniforme
 for(kcc=nsct2; kcc<nsct3; kcc++) 
   mCasc[1]->AppendItem(PIColorMap::GetStandardColorMapName(kcc).c_str(), 201+kcc);