Index: /trunk/SophyaPI/PI/picmap.cc
===================================================================
--- /trunk/SophyaPI/PI/picmap.cc	(revision 2377)
+++ /trunk/SophyaPI/PI/picmap.cc	(revision 2378)
@@ -23,14 +23,15 @@
 //--
 
-#define  MXMAPIDS   29
+#define  MXMAPIDS   30
 static   int    MapNCols[MXMAPIDS] = {256, 256, 256, 256, 256, 256, 256, 256, 256, 256,
                             256, 256, 256, 256, 256, 256, 256, 256, 256, 256, 256, 256,
-256, 256, 256, 256};
+256, 256, 256, 256, 256};
 
 // Tables de couleurs :
 // 5 Standard PI , 32  couleurs
 // 4 Standard PI , 128 couleurs
-// 4 Standard PI , 32 couleurs uniformes
+// 7 Standard PI , 32 couleurs uniformes
 // 12 MIDAS , 256 couleurs
+// 1 Standard PI 256 couleurs arcenciel avec intensites
 // 1 Standard PI 16 couleurs
 
@@ -44,5 +45,5 @@
                       "MIDAS_Stairs9","MIDAS_StairCase","MIDAS_Color",
                       "MIDAS_ManyCol","MIDAS_Idl14","MIDAS_Idl15",
-                      "Rainbow16"};
+                      "Rainbow256","Rainbow16"};
 
 static   CMapId MapIds[MXMAPIDS] = { 
@@ -55,5 +56,5 @@
                       CMAP_MIDAS_Stairs9, CMAP_MIDAS_StairCase, CMAP_MIDAS_Color, 
                       CMAP_MIDAS_ManyCol, CMAP_MIDAS_Idl14, CMAP_MIDAS_Idl15, 
-                      CMAP_COL16 } ;
+                      CMAP_Rainbow256, CMAP_COL16 } ;
 
 static   int mColTNums[8192];   // Max 8192 tables differentes pour le moment  
@@ -67,5 +68,5 @@
                                   NULL, NULL, NULL, NULL, NULL,
                                   NULL, NULL, NULL, NULL, NULL, 
-                                  NULL, NULL, NULL, NULL };
+                                  NULL, NULL, NULL, NULL, NULL };
 
 int  PIColorMap::NumberStandardColorMaps()
@@ -116,4 +117,5 @@
 //|	CMAP_CYAN32     :  32 couleurs, nuances de cyan
 //|	CMAP_VIOLET32   :  32 couleurs, nuances de violet
+//|	CMAP_Rainbow256 :  256 Couleurs arcenciel avec intensites
 //|	CMAP_COL16      :  16 Couleurs arcenciel
 //|	CMAP_OTHER      :  Table non standard (Midas,Idl, ...)
@@ -481,4 +483,21 @@
       break;
 
+    case CMAP_Rainbow256 : 
+      {
+	double fci[8] = {0.1, 0.6, 0.8, 1.0, 0.7, 0.8, 0.9, 1.0};
+	for(i=0; i<256; i++) {
+	  int ki = i/64;
+	  int kc = i%64;
+	  int kr = kc%4; 
+	  kc = kc/4;
+	  int kg = kc%4;
+	  int kb = kc/4;
+	  mycol.red = (fci[kr]*fci[ki]*65000.);
+	  mycol.green = (fci[kg]*fci[ki]*65000.); 
+	  mycol.blue = (fci[kb]*fci[ki]*65000.); 
+	  AllocColor(mycol, i);	  
+	}
+      }
+      break;
 //----------------------------------------------------------
 //----------------------------------------------------------
Index: /trunk/SophyaPI/PI/picmap.h
===================================================================
--- /trunk/SophyaPI/PI/picmap.h	(revision 2377)
+++ /trunk/SophyaPI/PI/picmap.h	(revision 2378)
@@ -47,4 +47,5 @@
 
  //  Table simple a 16 couleurs 
+ CMAP_Rainbow256  = 777,       // 256 Couleurs Arcenciel/intensite
  CMAP_COL16       = 999        // 16 Couleurs Arcenciel
  };
Index: /trunk/SophyaPI/PI/pidrwtools.cc
===================================================================
--- /trunk/SophyaPI/PI/pidrwtools.cc	(revision 2377)
+++ /trunk/SophyaPI/PI/pidrwtools.cc	(revision 2378)
@@ -182,5 +182,5 @@
 mOpt[1]->AppendPDMenu(mCasc[1]);
 //  Apres les tables importees de MIDAS
-nsct4 = PIColorMap::NumberStandardColorMaps()-1; // Les reste jusqu'a l'avant derniere
+nsct4 = PIColorMap::NumberStandardColorMaps()-2; // Les reste jusqu'a l'avant derniere
 for(kcc=nsct3; kcc<nsct4; kcc++) 
   mCasc[2]->AppendItem(PIColorMap::GetStandardColorMapName(kcc).c_str(), 201+kcc);
Index: /trunk/SophyaPI/PI/piimgtools.cc
===================================================================
--- /trunk/SophyaPI/PI/piimgtools.cc	(revision 2377)
+++ /trunk/SophyaPI/PI/piimgtools.cc	(revision 2378)
@@ -172,5 +172,5 @@
 mOptzc[0]->AppendPDMenu(mCasc[1]);
 //  Apres les tables importees de MIDAS
-nsct4 = PIColorMap::NumberStandardColorMaps()-1; // Les reste jusqu'a l'avant derniere
+nsct4 = PIColorMap::NumberStandardColorMaps()-2; // Les reste jusqu'a l'avant derniere
 for(kcc=nsct3; kcc<nsct4; kcc++) 
   mCasc[2]->AppendItem(PIColorMap::GetStandardColorMapName(kcc).c_str(), 201+kcc);